// --- [ sun.h ] --------------------------------------------------------------
//       29.03.09
//       tab = 3
//
// ----------------------------------------------------------------------------


// -> sun.c
// double geo_laenge = 10.50;			// Geographische Lnge des Standortes:  10'30"
// double geo_breite = 52.15;			// Geographische Breite des Standortes: 52'10"
												// Annahme: Ortszeit = UTC + 1h
// double azimut, elevation;

// --- Prototypen -------------------------------------------------------------
void out_float(double f, uint8_t vorkomma);
void SUN_calc(void);
void SUN_display(void);
void SUN_check_sunrise(void);
void SUN_print(uint16_t, uint8_t, uint8_t);

extern void DCF_incr_time(uint8_t *time, uint8_t m);
extern void DCF_decr_time(uint8_t *time, uint8_t m);
extern void DCF_copy_time(uint8_t *time1, uint8_t *time2);
extern void DCF_make_UTC_time(void);
extern uint8_t is_summertime(uint8_t *time);

//-----------------------------------------------------------------------------
// Konstanten
//-----------------------------------------------------------------------------

#define ELEVATION  		-4.0			// massgeblicher Winkel fr Sonnenuntergang/aufgang

#define KO 					57.29577951 // Umrechnungsfaktor von Grad nach Rad und umgekehrt
#define M_2PI 				6.283185307 // Kreiszahl 2PI

												// Im Array time[SUN][] sind die Daten etwas 'bunt' verteilt:
												// Index
#define SUN_EL_HIGH		0				// Elevation * 100 als  int16_t, High-Byte
#define SUN_EL_LOW		1				// Elevation * 100 als  int16_t, Low -Byte
#define SUN_AZ_HIGH		2				// Azimut    * 100 als uint16_t, High-Byte
#define SUN_AZ_LOW		3				// Azimut    * 100 als uint16_t, Low -Byte
#define SUN_UP_H			4				// Sonnenaufgang   Ortszeit Stunden
#define SUN_UP_M			5				// Sonnenaufgang   Ortszeit Minuten
#define SUN_DN_H			6				// Sonnenuntergang Ortszeit Stunden
#define SUN_DN_M			7				// Sonnenuntergang Ortszeit Minuten

#define PLUS				'+'
#define MINUS				'-'

// --- [ eof ] ----------------------------------------------------------------